package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ImageUploadLog;
import com.izouma.awesomeadmin.service.ImageUploadLogService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/imageUploadLog")
@RequiresAuthentication
public class ImageUploadLogController {

    @Autowired
    private ImageUploadLogService imageUploadLogService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ImageUploadLog record) {
        List<ImageUploadLog> pp = imageUploadLogService.getImageUploadLogList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getImageUploadLog", method = RequestMethod.GET)
    @ResponseBody
    public Result getImageUploadLog(@RequestParam(required = false, value = "id") String id) {
        ImageUploadLog data = imageUploadLogService.getImageUploadLogById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ImageUploadLog record) {
        ImageUploadLog data = imageUploadLogService.getImageUploadLog(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ImageUploadLog record) {
        Map<String, Object> result = new HashMap<>();

        List<ImageUploadLog> pp =imageUploadLogService.getImageUploadLogByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ImageUploadLog record) {
        boolean num = imageUploadLogService.createImageUploadLog(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateImageUploadLog(ImageUploadLog record) {
        boolean num = imageUploadLogService.updateImageUploadLog(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteImageUploadLog(@RequestParam(required = true, value = "id") String id) {

        boolean num = imageUploadLogService.deleteImageUploadLog(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ImageUploadLog record) throws Exception {

    List<ImageUploadLog> imageUploadLogs = imageUploadLogService.getImageUploadLogList(record);


        String sheetName = "image_upload_log";
        String titleName = "图片上传日志数据表";
        String fileName = "图片上传日志表";
        int columnNumber = 14;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "名称" ,   "地址" ,   "店铺" ,   "订单" ,   "用户" ,   "类型" ,   "大小" ,   "使用"  };
        String[][] dataList = new String[imageUploadLogs.size()][14];

        for (int i = 0; i < imageUploadLogs.size(); i++) {

                        dataList[i][0] = String.valueOf(imageUploadLogs.get(i).getId());
                        dataList[i][1] = String.valueOf(imageUploadLogs.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(imageUploadLogs.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(imageUploadLogs.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(imageUploadLogs.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(imageUploadLogs.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(imageUploadLogs.get(i).getImageName());
                        dataList[i][7] = String.valueOf(imageUploadLogs.get(i).getUrl());
                        dataList[i][8] = String.valueOf(imageUploadLogs.get(i).getStoreId());
                        dataList[i][9] = String.valueOf(imageUploadLogs.get(i).getOrderId());
                        dataList[i][10] = String.valueOf(imageUploadLogs.get(i).getUserId());
                        dataList[i][11] = String.valueOf(imageUploadLogs.get(i).getTypeFlag());
                        dataList[i][12] = String.valueOf(imageUploadLogs.get(i).getImageSize());
                        dataList[i][13] = String.valueOf(imageUploadLogs.get(i).getUseFlag());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

